<?php
defined('_JEXEC') or die;
jimport('joomla.application.component.modeladmin');

/* Модель Mozaika */
class MozaikaModelMozaika extends JModelAdmin
{
	/* Возвращает ссылку на объект таблицы, всегда его создавая */
	public function getTable($type = 'Mozaika', $prefix = 'MozaikaTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	
	/* Метод для получения формы */
	public function getForm($data = array(), $loadData = true) 
	{
		/* Получаем форму */
		$form = $this->loadForm('com_mozaika.mozaika', 'mozaika',
								array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form))
		{
			return false;
		}

		return $form;
	}

	/* Метод для получения скрипта, который будет включен в форму */
	public function getScript() 
	{
		return 'administrator/components/com_mozaika/models/forms/mozaika.js';
	}

	/* Метод для получения данных, которые должны быть  загружены в форму */
	protected function loadFormData() 
	{
		/* Проверка сессии на наличие ранее введеных в форму данных */
		$data = JFactory::getApplication()->getUserState('com_mozaika.edit.mozaika.data', array());
		if (empty($data)) 
		{
			$data = $this->getItem();
		}
		return $data;
	}

	/* Метод для проверки, может ли пользователь удалять существующую запись */
	protected function canDelete($record)
	{
		if (!empty($record->id))
		{
			return JFactory::getUser()->authorise('core.delete', 'com_mozaika.message.' . (int)$record->id);
		}
	}
}