<?php
defined('_JEXEC') or die;
jimport('joomla.application.component.view');

/* HTML представление редактирования сообщения */
class MozaikaViewMozaika extends JViewLegacy
{
	/* Сообщение */
	protected $item;
	/* Объект формы */
	protected $form;
	/* JavaScript файл валидации формы */
	protected $script;
	/* Доступы пользователя */
	protected $canDo;

	/* Отображает представление */
	public function display($tpl = null) 
	{
		/* Получаем данные из модели */
		$this->form = $this->get('Form');
		$this->item = $this->get('Item');
		$this->script = $this->get('Script');

		/* Есть ли ошибки */
		if (count($errors = $this->get('Errors'))) 
		{
			JFactory::getApplication()->enqueueMessage(implode('<br />', $errors), 'error');
		}

		/* Получаем доступы пользователя */
		$this->canDo = MozaikaHelper::getActions($this->item->id);

		/* Устанавливаем панель инструментов */
		$this->addToolBar();

		/* Отображаем представление */
		parent::display($tpl);

		/* Устанавливаем документ */
		$this->setDocument();
	}

	/* Устанавливает панель инструментов */
	protected function addToolBar() 
	{
		$input = JFactory::getApplication()->input->set('hidemainmenu', true);
		$isNew = ($this->item->id == 0);

		JToolBarHelper::title($isNew ? JText::_('COM_MOZAIKA_MANAGER_MOZAIKA_NEW')
								: JText::_('COM_MOZAIKA_MANAGER_MOZAIKA_EDIT'), 'mozaika');

		/* Устанавливаем действия для новых и существующих записей */
		if ($isNew) 
		{
			/* Для новых записей проверяем право создания */
			if ($this->canDo->get('core.create')) 
			{
				JToolBarHelper::apply('mozaika.apply', 'JTOOLBAR_APPLY');
				JToolBarHelper::save('mozaika.save', 'JTOOLBAR_SAVE');
				JToolBarHelper::custom('mozaika.save2new', 'save-new.png', 'save-new_f2.png',
										'JTOOLBAR_SAVE_AND_NEW', false);
			}
			JToolBarHelper::cancel('mozaika.cancel', 'JTOOLBAR_CANCEL');
		}
		else
		{
			/* Для существующих записей проверяем право редактирования */
			if ($this->canDo->get('core.edit'))
			{
				/* Мы можем сохранять новую запись */
				JToolBarHelper::apply('mozaika.apply', 'JTOOLBAR_APPLY');
				JToolBarHelper::save('mozaika.save', 'JTOOLBAR_SAVE');

				/* Мы можем сохранять  в новую запись, но нужна проверка на создание */
				if ($this->canDo->get('core.create')) 
				{
					JToolBarHelper::custom('mozaika.save2new', 'save-new.png', 'save-new_f2.png',
											'JTOOLBAR_SAVE_AND_NEW', false);
				}
			}

			/* Для сохранения копии записи проверяем право создания */
			if ($this->canDo->get('core.create')) 
			{
				JToolBarHelper::custom('mozaika.save2copy', 'save-copy.png', 'save-copy_f2.png',
										'JTOOLBAR_SAVE_AS_COPY', false);
			}
			JToolBarHelper::cancel('mozaika.cancel', $isNew ? 'JTOOLBAR_CANCEL' : 'JTOOLBAR_CLOSE');
		}
	}

	/* Метод для установки свойств документа */
	protected function setDocument() 
	{
		$document = JFactory::getDocument();
		$document->addScript(JURI::root() . $this->script);
		$document->addScript(JURI::root() . "/administrator/components/com_mozaika"
										. "/views/mozaika/submitbutton.js");
		JText::script('COM_MOZAIKA_MOZAIKA_ERROR_UNACCEPTABLE');
	}
}