<?php
defined('_JEXEC') or die;
jimport('joomla.application.component.view');

/* HTML представление списка сообщений компонента Mozaika */
class MozaikaViewMozaikas extends JViewLegacy
{
	/* Сообщения */
	protected $items;

	/* Постраничная навигация */
	protected $pagination;

	/* Доступы пользователя */
	protected $canDo;

	/* Отображает список сообщений */
	public function display($tpl = null) 
	{
		/* Получаем данные из модели */
		$this->items = $this->get('Items');

		/* Получаем объект постраничной навигации */
		$this->pagination = $this->get('Pagination');

		/* Есть ли ошибки */
		if (count($errors = $this->get('Errors'))) 
		{
			JFactory::getApplication()->enqueueMessage(implode('<br />', $errors), 'error');
		}

		/* Получаем доступы пользователя */
		$this->canDo = MozaikaHelper::getActions();

		/* Устанавливаем панель инструментов */
		$this->addToolBar();
 
		/* Отображаем представление */
		parent::display($tpl);
	}

	/* Устанавливает панель инструментов */
	protected function addToolBar() 
	{
		JToolBarHelper::title(JText::_('COM_MOZAIKA_MANAGER_MOZAIKAS'), 'mozaika');
		if ($this->canDo->get('core.create'))
		{
			JToolBarHelper::addNew('mozaika.add');
		}
		if ($this->canDo->get('core.edit'))
		{
			JToolBarHelper::editList('mozaika.edit');
		}
		if ($this->canDo->get('core.delete'))
		{
			JToolBarHelper::divider();
			JToolBarHelper::deleteList('', 'mozaikas.delete');
		}
		if ($this->canDo->get('core.admin'))
		{
			JToolBarHelper::divider();
			JToolBarHelper::preferences('com_mozaika');
		}
	}
}