﻿package doc_as {
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import flash.utils.Timer;
	import flash.net.URLRequest;
	
	public class Main extends MovieClip {
		
		public static var par:FlashVars;
		public static var stg:Stage;
		
		private var otR:Otrabotka    = new Otrabotka();             /* Объекты пользовательских классов проекта */
		private var arR:RabotaArray  = new RabotaArray();
		private var vybV:VyborVar;
		private var setk:Setka;
		
		private var imgI:Loader;                                    /* Загрузка картинки-исходника игры */
		private var varI:Array = [6, 24, 96, 150, 600];             /* Варианты игры, количество фрагментов */
		private var bmpI:Bitmap;
		private var bmpD:BitmapData;
        
		private var zgrA:Array;                                     /* Список ссылок файлов загр.окончания игры(полный) */
		private var zgrB:Array;                                     /* Список ссылок файлов загр.окончания игры(уникальный) */
		private var lodB:Array;                                     /* Массив Loader-ов по списку zgrB */
		private var krdI:Array;                                     /* "Правильные" координаты фрагментов, двум.массив */
		private var frgm:Array;                                     /* Массив фрагментов картинки */
		private var sprt:Array;                                     /* Массив спрайтов управляющих фрагметами */
		private var logI:Array;                                     /* Массив булевых значений, опред.конец игры */
		private var logU:Array;                                     /* Массив булевых значений опред.уст.фрагм.в позицию */
		private var igra:Boolean;                                   /* Определяет игра - не игра */
		private var zFrgB:int;                                      /* Max z-индекс расстановки фрагментов */
		private var zFrgM:int;                                      /* Max z-индекс расстановки спрайтов */
		private var numVI:int;                                      /* Принимает вариант игры как индекс массива varI */
		private var tim1:Timer;
		
		public function Main() {
			par = new FlashVars(loaderInfo.parameters);
			stg = stage;
			this.risFonStage();                                     /* Окраска фона swf-файла */
			setChildIndex(addChild(otR.zagrVneshFile(par.osnfon, 0, 0)), 0);  /* Основной фон */
			imgI = otR.zagrVneshFile(par.podlka, 25, 75);           /* Загрузка основы(матрицы) игры */
			imgI.contentLoaderInfo.addEventListener(Event.COMPLETE, zagruzKartinka);
			setChildIndex(addChild(imgI), 1);
			imgI.alpha = par.alphai;
		}
		/* Функция вызываемая после загрузки картинки-основы игры */
		private function zagruzKartinka(sob:Event):void{
			bmpD = sob.target.content.bitmapData;
			this.osnOtrabotka(par.pazzly);
		}
		
		/* Основная рабочая функция, arg1 - количество фрагментов в варианте игры. */
		private function osnOtrabotka(arg1:int):void{
			igra = true;
			tim1 = new Timer(50, 0);
			numVI = varI.indexOf(arg1);
			if(setk) setk.visible = false;                          /* Каркасная сетка, удал.возможн.старой и созд.новой */
			setk = new Setka(arg1);
			setChildIndex(addChild(setk), 2);
			var arrVr1:Array = otR.configuracya(arg1, bmpD);
			frgm = arrVr1[0];
			sprt = arrVr1[1];
			krdI = arrVr1[2];
			zFrgB = this.vyvAddChildZ(frgm, 3);                     /* Выв.фрагм.и получен max для фрагм.z-инд. */
			zFrgM = this.vyvAddChildZ(sprt, zFrgB + 1);
			zagruzEnd(zFrgM + 1);                                   /* Загрузка файлов окончания игры */
			for(var i:int = 0; i < sprt.length; i++){
				spriteClick(i);
			}
			vyvodVariantov();                                       /* Вывод блока выбора вариантов игры. */
			logI = arR.sozdOdnorodnArr(frgm.length, false);
			logU = arR.sozdOdnorodnArr(frgm.length, false);
			sborFragm();                                            /* Перенос всех фраментов вверх и сборка в одну кучу. */
			
		}
		
		/* Загрузка файлов окончания игры */
		private function zagruzEnd(arg1:int):void{
			lodB = new Array();
			zgrA = String(par.endigr).split("|");                   /* Полный список ссылок файлов окончания игры */
			zgrB = arR.arrUnicZnach(zgrA);                          /* Список уникальных ссылок файлов окончания игры  */
			for(var i:int = 0; i < zgrB.length; i++){
				lodB[i] = otR.zagrVneshFile(zgrB[i], 25, 75);
				setChildIndex(addChild(lodB[i]), arg1 + i);
				lodB[i].visible = false;
			}
		}
		
		/* Перенос всех фраментов вверх и сборка в одну кучу. */
		private function sborFragm():void{
			var sbr:Sborka = new Sborka();                          
			addChild(sbr);
			sbr.addEventListener(MouseEvent.CLICK, perenosFragm);
			function perenosFragm(sob:MouseEvent):void{
				if(igra == true){
				    for(var i:int=0; i < frgm.length; i++){
						if(logU[i] == false){
							frgm[i].x = sprt[i].x = (800 - frgm[i].width)/2;
					        frgm[i].y = sprt[i].y = 10;
							spriteClick(i);
						}
				    }
				}
			}
		}
		
		/* События блока вывода вариантов игры - количества фрагментов */
		private function vyvodVariantov():void{
			vybV = new VyborVar();
			addChild(vybV);
			vybV.btn0.addEventListener(MouseEvent.MOUSE_DOWN, newVar0);
			function newVar0(sob:MouseEvent):void{ newVariant(varI[0]); }
			
			vybV.btn1.addEventListener(MouseEvent.MOUSE_DOWN, newVar1);
			function newVar1(sob:MouseEvent):void{ newVariant(varI[1]); }
			
			vybV.btn2.addEventListener(MouseEvent.MOUSE_DOWN, newVar2);
			function newVar2(sob:MouseEvent):void{ newVariant(varI[2]); }
			
			vybV.btn3.addEventListener(MouseEvent.MOUSE_DOWN, newVar3);
			function newVar3(sob:MouseEvent):void{ newVariant(varI[3]); }
			
			vybV.btn4.addEventListener(MouseEvent.MOUSE_DOWN, newVar4);
			function newVar4(sob:MouseEvent):void{ newVariant(varI[4]); }
			
			function newVariant(arg1:int):void{
				vybV.visNotVisible(false);
				otR.visNotVisibl(lodB, false);
		        var contS:Sprite = new Sprite();
				addChild(contS);
				for(var i:int = 0; i < sprt.length; i++){
					contS.addChild(sprt[i]);
					contS.removeChild(sprt[i]);
				}
				var contB:Sprite = new Sprite();
				addChild(contB);
				for(i=0; i < frgm.length; i++){
					contB.addChild(frgm[i]);
					contB.removeChild(frgm[i]);
				}
				osnOtrabotka(arg1);
			}
		}
		
		/* Захват, удержание и перенос фрагментов картинки по рабочей области. */
		private function spriteClick(arg1:int):void{
			sprt[arg1].addEventListener(MouseEvent.MOUSE_DOWN, sprPerenos);
			sprt[arg1].addEventListener(MouseEvent.MOUSE_UP, sprStopPer);
			function sprPerenos(sob:MouseEvent):void{
				setChildIndex(frgm[arg1], zFrgB);
				setChildIndex(sprt[arg1], zFrgM);
				logI[arg1] = false;
				logU[arg1] = false;
				sprt[arg1].startDrag();
				tim1.addEventListener(TimerEvent.TIMER, startBitmap);
	            tim1.start();
			}
			function sprStopPer(sob:MouseEvent):void{
				sprt[arg1].stopDrag();
				zalipanie(arg1);                           /* "Прилипание" к сетке, пров.окончания игры */
				tim1.stop();
			}
			function startBitmap(sob:TimerEvent):void{
				frgm[arg1].x = sprt[arg1].x;
				frgm[arg1].y = sprt[arg1].y;
			}
		}
		
		/* "Прилипание" фрагмента и спрайта к сетке после отпуска мыши. В данной функции
		   происходит проверка на --------------- ОКОНЧАНИЕ ИГРЫ --------------------- */
		private function zalipanie(arg1:int):void{
			var arrVr1:Array = otR.schemaRasst(sprt.length);
			var zazor:Number = 5;
			var krX:Number;
			var krY:Number;
			for(var i:int = 0; i < arrVr1[0]; i++){
				krX = (i * sprt[arg1].width) + 25;
				for(var k:int = 0; k < arrVr1[1]; k++){
					krY = (k * sprt[arg1].width) + 75;
					if((sprt[arg1].x >= krX - zazor) && (sprt[arg1].x <= krX + zazor) && (sprt[arg1].y >= krY - zazor) && (sprt[arg1].y <= krY + zazor)){
						frgm[arg1].x = sprt[arg1].x = krX;
						frgm[arg1].y = sprt[arg1].y = krY;
						logU[arg1] = true;
						if(sprt[arg1].x == krdI[0][arg1] && sprt[arg1].y == krdI[1][arg1]){
							logI[arg1] = true;
							var bul:Boolean = arR.provOdnorArray(logI, true);
							if(bul == true){
								igra = false;
								if(zgrA.length == 1)lodB[0].visible = true;
								else if(zgrA.length == 5) {
									lodB[zgrB.indexOf(zgrA[numVI])].visible = true;
								}
							}
						}
					}
				}
			}
		}

		/* Присвоение z-индекса массиву объектов с выводом addChild, Аргументы: 1.Массив
		   объектов, 2.Начальный z-индекс. Возвращает z-индекс последнего объекта. */
		private function vyvAddChildZ(arg1:Array, arg2:int):int{
			var rez:int = arg2;
			for(var i:int = 0; i < arg1.length; i++){
				setChildIndex(addChild(arg1[i]), arg2 + i);
				rez = arg2 + i;
			}
			return rez;
		}
		
		/* Окраска фона swf-файла */ 
		private function risFonStage():void{
			this.graphics.beginFill(par.colswf);                                      
            this.graphics.drawRect( -1000, -1000, 2800, 2600);
            this.graphics.endFill()
		}
		
		
	}
}
