<?php
defined('_JEXEC') or die;
jimport('joomla.application.component.modelitem');

/* Модель сообщения компонента Mozaika. */
class MozaikaModelMozaika extends JModelItem
{
	/* Сообщение */
	protected $item;

	/* Возвращает ссылку на объект таблицы */
	public function getTable($type = 'Mozaika', $prefix = 'MozaikaTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	/* Получаем сообщение */
	public function getItem() 
	{
		if (!isset($this->item)) 
		{
			$id = $this->getState('message.id');

			/* Конструируем SQL запрос */
			$this->_db->setQuery($this->_db->getQuery(true)
					->select('h.swfwdt, h.osnfon, h.podlka, h.alphai, h.endigr, h.pazzly, h.colswf, h.colset,
					          h.alpset, h.colvfn, h.colvob, h.editra, h.editrb, c.title as category')
					->from('#__mozaika as h')
					->leftJoin('#__categories as c ON h.catid=c.id')
					->where('h.id=' . (int)$id));

			if (!$this->item = $this->_db->loadObject()) 
			{
				$this->setError($this->_db->getError());
			}
			else
			{
				/* Загружаем JSON строку параметров */
				$params = new JRegistry;
				$params->loadString($this->item->params);
				$this->item->params = $params;
                /* Формирование строки переменных FlashVars */
				$this->item->strFlVar = $this->strokaFlashVars($this->item);
				/* Объединяем глобальные параметры с индивидуальными */
				$params = clone $this->getState('params');
				$params->merge($this->item->params);
				$this->item->params = $params;
			}
		}

		return $this->item;
	}
	
	/* Функция получения строки FlashVars, переменных передаваемых в SWF-файл */
	private function strokaFlashVars($dann)
	{
		$rez = 'swfzag='.$dann->swfzag.'&osnfon='.$dann->osnfon.'&podlka='.$dann->podlka.'&alphai='.$dann->alphai.
		      '&endigr='.$dann->endigr.'&pazzly='.$dann->pazzly.'&colswf='.$dann->colswf.'&colset='.$dann->colset.
			  '&alpset='.$dann->alpset.'&colvfn='.$dann->colvfn.'&colvob='.$dann->colvob;
		
        return $rez;
	}	

	/* Метод для авто-заполнения состояния модели */
	protected function populateState() 
	{
		$app = JFactory::getApplication();

		/* Получаем Id сообщения из Запроса */
		$id = $app->input->getInt('id');

		/* Добавляем Id сообщения в состояние модели */
		$this->setState('message.id', $id);

		/* Загружаем глобальные параметры */
		$params = $app->getParams();

		/* Добавляем параметры в состояние модели */
		$this->setState('params', $params);

		parent::populateState();
	}
}